"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

from IO_Manager import *
from Model import *
import random
from ActionGroup import ActionGroup

class Observer:
    def buildObjects(self):
        
        self.onlyOneColor = False
        self.output = []

        self.mode,self.maxX,self.maxY,self.nCycles,self.nChams,brain,self.brainPath,smartColor,self.seed = getInputs()
        random.seed(self.seed)

        self.model = Model(self,self.nChams,["blue","red","green"],\
                           self.nCycles,self.maxX,self.maxY,self.mode,brain,smartColor)

        self.model.buildObjects()


    def buildActions(self):

        self.model.buildActions()

        self.outputActionGroup = ActionGroup ("output")

        def showUp(self):
            if self.model.time%500 == 0:
                print self.model.time

        def storeOutput(self):
            nChamsXColor = [0]*3
            for i in range(3):
                for chameleon in self.model.chList:
                    if chameleon.color == self.model.colorList[i]:
                        nChamsXColor[i]+=1
                        
            self.output.append(str(nChamsXColor[0]) + " " + str(nChamsXColor[1]) + " "\
                               + str(nChamsXColor[2]) + "\n")


        self.outputActionGroup.actions = [showUp, storeOutput]


        self.actionGroupList = ['step','output']


    
    def run(self):
        
        while (self.model.time<self.nCycles) and not(self.onlyOneColor):

            for actionType in self.actionGroupList :
                if actionType == 'step' :
                    self.model.step()
                elif actionType == 'output' :
                    for action in self.outputActionGroup.actions:
                        action(self)
                    
        if self.onlyOneColor :
            print "Chameleons stopped changing at cycle num. ", self.model.time, \
                  ". The winning color is ",self.model.chList[0].color
        else :
            print self.nCycles, "cycles have passed. Neither color has won."

        if self.mode == "T":
            storeBrain(self.model.AI.brain, self.brainPath)

        self.storeOutput()

        

    def storeOutput(self):
        i=0
        while 1:
            path='output'
            if i == 0:
                add = '.txt'
            else :
                add = str(i)+'.txt'
            path = path + add
            try :
                file_=open(path,'r')
                file_.close()
                i+=1
                continue
            except IOError:
                file_=open(path,'w')
                file_.writelines(self.output)
                file_.close
                break
        print "The output has been stored to " + path

        
