"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

from Tkinter import *
from tkFont import *

class OutputWindow(Toplevel):
    def __init__(self,parent):
        Toplevel.__init__(self,parent)
        
        self.parent = parent
        self.title("Output")
        self.geometry("%dx%d%+d%+d" % (160, 160, 0, 0))
        self.resizable(False,False)

        self.protocol("WM_DELETE_WINDOW", self.handler)
        
        myFont = Font(family="Terminal", size=14)
        mySmallFont = Font(family="Terminal", size=10)

        Label(self, font = myFont, fg = "blue", text="Blue :").grid(row=0,sticky = W)
        Label(self, font = myFont, fg = "red", text="Red :").grid(row=1,sticky = W)
        Label(self, font = myFont, fg = "green", text="Green :").grid(row=2,rowspan=2,sticky = W)

        Label(self, fg = "blue", font = myFont, textvariable = self.parent.blueNumber).grid(row=0,column=1)
        Label(self, fg = "red", font = myFont, textvariable = self.parent.redNumber).grid(row=1,column=1)
        Label(self, fg = "green", font = myFont, textvariable = self.parent.greenNumber).grid(row=2,column=1)

        self.cycleFrame = Frame(self)
        self.cycleFrame.grid(row=4,sticky=N+S+W+E,pady=10)
        Label(self.cycleFrame, font = mySmallFont, text="Cycle :").grid(row=0)
        Label(self.cycleFrame, font = mySmallFont, justify = LEFT,  textvariable = self.parent.cycles).grid(row=0,column=1)


    def handler(self):
        self.parent.focus_set()
        self.withdraw()
